From 66a641992b5617d4bab2295617f6b6bf30c72175 Mon Sep 17 00:00:00 2001
From: Osamu Aoki <osamu@debian.org>
Date: Sat, 5 Sep 2015 23:19:20 +0900
Subject: [PATCH 3/4] qx/script/

---
 scripts/uscan.pl | 20 ++++++++++++++++++--
 1 file changed, 18 insertions(+), 2 deletions(-)

diff --git a/scripts/uscan.pl b/scripts/uscan.pl
index 9a2d889..5baf618 100644
--- a/scripts/uscan.pl
+++ b/scripts/uscan.pl
@@ -2943,12 +2943,28 @@ sub safe_replace($$) {
     my ($in, $pat) = @_;
     $pat =~ s/^\s*(.*?)\s*$/$1/;
 
-    $pat =~ /^(s|tr|y)(.)/;
+    $pat =~ /^(s|tr|y|qx)(.)/;
     my ($op, $sep) = ($1, $2 || '');
     my $esc = "\Q$sep\E";
     my ($parsed_ok, $regexp, $replacement, $flags);
 
-    if ($sep eq '{' or $sep eq '(' or $sep eq '[' or $sep eq '<') {
+    if ($op eq 'qx') {
+	my $input = $$in;
+	my $output;
+	# script name: [a-zA-Z0-9][-_a-zA-Z0-9]* (any quotation dropped)
+	$pat  =~ s/^qx[^-_a-zA-Z0-9]*([a-zA-Z0-9][-_a-zA-Z0-9]*)[^-_a-zA-Z0-9]*$/debian\/$1/;
+	if ( -x $pat) {
+	    spawn(exec => $pat,
+            from_string => \$input,
+            to_string => \$output,
+            wait_child => 1);
+	    $$in = $output;
+	    return 1;
+	} else {
+	    print STDERR "$progname warning: missing executable $pat: $!\n";
+	    return 0;
+	}
+    } elsif ($sep eq '{' or $sep eq '(' or $sep eq '[' or $sep eq '<') {
 	($parsed_ok, $regexp, $replacement, $flags) = quoted_regex_parse($pat);
 
 	return 0 unless $parsed_ok;
-- 
2.1.4

